﻿# This file is a part of alpha.

import ambient
import ambient.intrinsics


def _resolve_editor(editor):
	if editor is None:
		return ambient.active_window().selected_editor
	return editor


# character motion

def extend_to_forward_character(editor = None, n = 1):
	return ambient.intrinsics.forward_character(editor, True, n)

def extend_to_backward_character(editor = None, n = 1):
	return ambient.intrinsics.backward_character(editor, True, n)

def select_rows_to_forward_character(editor = None, n = 1):
	ambient.intrinsics.try_to_begin_rectangle_selection(editor)
	return extend_to_forward_character(editor, n)

def select_rows_to_backward_character(editor = None, n = 1):
	ambient.intrinsics.try_to_begin_rectangle_selection(editor)
	return extend_to_backward_character(editor, n)

def extend_to_left_character(editor = None, n = 1):
	return ambient.intrinsics.left_character(editor, True, n)

def extend_to_right_character(editor = None, n = 1):
	return ambient.intrinsics.right_character(editor, True, n)

def select_rows_to_left_character(editor = None, n = 1):
	ambient.intrinsics.try_to_begin_rectangle_selection(editor)
	return extend_to_left_character(editor, n)

def select_rows_to_right_character(editor = None, n = 1):
	ambient.intrinsics.try_to_begin_rectangle_selection(editor)
	return extend_to_right_character(editor, n)


# word motion

def extend_to_forward_word(editor = None, n = 1):
	return ambient.intrinsics.forward_word(editor, True, n)

def extend_to_backward_word(editor = None, n = 1):
	return ambient.intrinsics.backward_word(editor, True, n)

def extend_to_forward_word_end(editor = None, n = 1):
	return ambient.intrinsics.forward_word_end(editor, True, n)

def extend_to_backward_word_end(editor = None, n = 1):
	return ambient.intrinsics.backward_word_end(editor, True, n)

def select_rows_to_forward_word(editor = None, n = 1):
	ambient.intrinsics.try_to_begin_rectangle_selection(editor)
	return extend_to_forward_word(editor, n)

def select_rows_to_backward_word(editor = None, n = 1):
	ambient.intrinsics.try_to_begin_rectangle_selection(editor)
	return extend_to_backward_word(editor, n)

def select_rows_to_forward_word_end(editor = None, n = 1):
	ambient.intrinsics.try_to_begin_rectangle_selection(editor)
	return extend_to_forward_word_end(editor, n)

def select_rows_to_backward_word_end(editor = None, n = 1):
	ambient.intrinsics.try_to_begin_rectangle_selection(editor)
	return extend_to_backward_word_end(editor, n)

def extend_to_left_word(editor = None, n = 1):
	return ambient.intrinsics.left_word(editor, True, n)

def extend_to_right_word(editor = None, n = 1):
	return ambient.intrinsics.right_word(editor, True, n)

def extend_to_left_word_end(editor = None, n = 1):
	return ambient.intrinsics.left_word_end(editor, True, n)

def extend_to_right_word_end(editor = None, n = 1):
	return ambient.intrinsics.right_word_end(editor, True, n)

def select_rows_to_left_word(editor = None, n = 1):
	ambient.intrinsics.try_to_begin_rectangle_selection(editor)
	return extend_to_left_word(editor, n)

def select_rows_to_right_word(editor = None, n = 1):
	ambient.intrinsics.try_to_begin_rectangle_selection(editor)
	return extend_to_right_word(editor, n)

def select_rows_to_left_word_end(editor = None, n = 1):
	ambient.intrinsics.try_to_begin_rectangle_selection(editor)
	return extend_to_left_word_end(editor, n)

def select_rows_to_right_word_end(editor = None, n = 1):
	ambient.intrinsics.try_to_begin_rectangle_selection(editor)
	return extend_to_right_word_end(editor, n)


# buffer end motion

def extend_to_beginning_of_buffer(editor = None):
	return ambient.intrinsics.beginning_of_buffer(editor, True)

def extend_to_end_of_buffer(editor = None):
	return ambient.intrinsics.end_of_buffer(editor, True)

def select_rows_to_beginning_of_buffer(editor = None):
	ambient.intrinsics.try_to_begin_rectangle_selection(editor)
	return extend_to_beginning_of_buffer(editor)

def select_rows_to_end_of_buffer(editor = None):
	ambient.intrinsics.try_to_begin_rectangle_selection(editor)
	return extend_to_end_of_buffer(editor)


# text lines

def extend_to_beginning_of_line(editor = None):
	return ambient.intrinsics.beginning_of_line(editor, True)

def extend_to_end_of_line(editor = None):
	return ambient.intrinsics.end_of_line(editor, True)

def select_rows_to_beginning_of_line(editor = None):
	ambient.intrinsics.try_to_begin_rectangle_selection(editor)
	return extend_to_beginning_of_line(editor)

def select_rows_to_end_of_line(editor = None):
	ambient.intrinsics.try_to_begin_rectangle_selection(editor)
	return extend_to_end_of_line(editor)

def extend_to_first_printable_character_of_line(editor = None):
	return ambient.intrinsics.first_printable_character_of_line(editor, True)

def extend_to_last_printable_character_of_line(editor = None):
	return ambient.intrinsics.last_printable_character_of_line(editor, True)

def select_rows_to_first_printable_character_of_line(editor = None):
	ambient.intrinsics.try_to_begin_rectangle_selection(editor)
	return extend_to_first_printable_character_of_line(editor)

def select_rows_to_last_printable_character_of_line(editor = None):
	ambient.intrinsics.try_to_begin_rectangle_selection(editor)
	return extend_to_last_printable_character_of_line(editor)

def extend_to_contextual_beginning_of_line(editor = None):
	return ambient.intrinsics.contextual_beginning_of_line(editor, True)

def extend_to_contextual_end_of_line(editor = None):
	return ambient.intrinsics.contextual_end_of_line(editor, True)

def select_rows_to_contextual_beginning_of_line(editor = None):
	ambient.intrinsics.try_to_begin_rectangle_selection(editor)
	return extend_to_contextual_beginning_of_line(editor)

def select_rows_to_contextual_end_of_line(editor = None):
	ambient.intrinsics.try_to_begin_rectangle_selection(editor)
	return extend_to_contextual_end_of_line(editor)

def extend_to_forward_line(editor = None, n = 1):
	return ambient.intrinsics.forward_line(editor, True, n)

def extend_to_backward_line(editor = None, n = 1):
	return ambient.intrinsics.backward_line(editor, True, n)

def select_rows_to_forward_line(editor = None, n = 1):
	ambient.intrinsics.try_to_begin_rectangle_selection(editor)
	return extend_to_forward_line(editor, n)

def select_rows_to_backward_line(editor = None, n = 1):
	ambient.intrinsics.try_to_begin_rectangle_selection(editor)
	return extend_to_backward_line(editor, n)


# screen lines

def extend_to_beginning_of_visual_line(editor = None):
	return ambient.intrinsics.beginning_of_visual_line(editor, True)

def extend_to_end_of_visual_line(editor = None):
	return ambient.intrinsics.end_of_visual_line(editor, True)

def select_rows_to_beginning_of_visual_line(editor = None):
	ambient.intrinsics.try_to_begin_rectangle_selection(editor)
	return extend_to_beginning_of_visual_line(editor)

def select_rows_to_end_of_visual_line(editor = None):
	ambient.intrinsics.try_to_begin_rectangle_selection(editor)
	return extend_to_end_of_visual_line(editor)

def extend_to_first_printable_character_of_visual_line(editor = None):
	return ambient.intrinsics.first_printable_character_of_visual_line(editor, True)

def extend_to_last_printable_character_of_visual_line(editor = None):
	ambient.intrinsics.last_printable_character_of_visual_line(editor, True)

def select_rows_to_first_printable_character_of_visual_line(editor = None):
	ambient.intrinsics.try_to_begin_rectangle_selection(editor)
	return extend_to_first_printable_character_of_visual_line(editor)

def select_rows_to_last_printable_character_of_visual_line(editor = None):
	ambient.intrinsics.try_to_begin_rectangle_selection(editor)
	return extend_to_last_printable_character_of_visual_line(editor)

def extend_to_contextual_beginning_of_visual_line(editor = None):
	return ambient.intrinsics.contextual_beginning_of_visual_line(editor, True)

def extend_to_contextual_end_of_visual_line(editor = None):
	return ambient.intrinsics.contextual_end_of_visual_line(editor, True)

def select_rows_to_contextual_beginning_of_visual_line(editor = None):
	ambient.intrinsics.try_to_begin_rectangle_selection(editor)
	return extend_to_contextual_beginning_of_visual_line(editor)

def select_rows_to_contextual_end_of_visual_line(editor = None):
	ambient.intrinsics.try_to_begin_rectangle_selection(editor)
	return extend_to_contextual_end_of_visual_line(editor)

def extend_to_forward_visual_line(editor = None, n = 1):
	return ambient.intrinsics.forward_visual_line(editor, True, n)

def extend_to_backward_visual_line(editor = None, n = 1):
	return ambient.intrinsics.backward_visual_line(editor, True, n)

def select_rows_to_forward_visual_line(editor = None, n = 1):
	ambient.intrinsics.try_to_begin_rectangle_selection(editor)
	return extend_to_forward_visual_line(editor, n)

def select_rows_to_backward_visual_line(editor = None, n = 1):
	ambient.intrinsics.try_to_begin_rectangle_selection(editor)
	return extend_to_backward_visual_line(editor, n)

def extend_to_backward_page(editor = None, n = 1):
	return ambient.intrinsics.backward_page(editor, True, n)

def extend_to_forward_page(editor = None, n = 1):
	return ambient.intrinsics.forward_page(editor, True, n)

def select_rows_to_forward_page(editor = None, n = 1):
	ambient.intrinsics.try_to_begin_rectangle_selection(editor)
	return extend_to_forward_page(editor, n)

def select_rows_to_backward_page(editor = None, n = 1):
	ambient.intrinsics.try_to_begin_rectangle_selection(editor)
	return extend_to_backward_page(editor, n)


def extend_to_forward_bookmark(editor = None, n = 1):
	return ambient.intrinsics.forward_bookmark(editor, n)

def extend_to_backward_bookmark(editor = None, n = 1):
	return ambient.intrinsics.backward_bookmark(editor, n)

def select_rows_to_forward_bookmark(editor = None, n = 1):
	ambient.intrinsics.try_to_begin_rectangle_selection(editor)
	return extend_to_forward_bookmark(editor, n)

def select_rows_to_backward_bookmark(editor = None, n = 1):
	ambient.intrinsics.try_to_begin_rectangle_selection(editor)
	return extend_to_backward_bookmark(editor, n)


# narrowing

def narrow_to_selected_region(editor = None, n = None):
	'''Restricts editing in the active text editor to the current selection.'''
	editor = _resolve_editor(editor)
	if editor.caret.selected_region.is_empty():
		ambient.error('The selection is empty.')
	editor.buffer.narrow_to_region(editor.caret.selected_region)

def widen(editor = None, n = None):
	_resolve_editor(editor).buffer.widen()


def cut_selection(editor = None):
	'''Cuts the selection and puts it on the clipboard.'''
	if editor is None:
		editor = ambient.active_window().selected_editor
	editor.caret.cut_selection(True)

def copy_selection(editor = None):
	'''Copies the selection and puts it on the clipboard.'''
	if editor is None:
		editor = ambient.active_window().selected_editor
	editor.caret.copy_selection(True)

def paste(editor = None):
	if editor is None:
		editor = ambient.active_window().selected_editor
	ambient.intrinsics.paste(editor, False)

def paste_from_killring(editor = None):
	if editor is None:
		editor = ambient.active_window().selected_editor
	ambient.intrinsics.paste(editor, True)

def toggle_bookmark(window = None):
	'''Sets or removes bookmark on the current line.'''
	if window is None:
		window = ambient.active_window()
	window.selected_buffer.bookmarker.toggle(window.selected_editor.caret.line)

def clear_all_bookmarks():
	'''Removes the all bookmarks.'''
	ambient.active_buffer().bookmarker.clear()

def search_forward_again(n = 1):
	return ambient.intrinsics.search_again(ambient.Direction.forward, n)

def search_backward_again(n = 1):
	return ambient.intrinsics.search_again(ambient.Direction.backward, n)

def isearch_forward():
	return ambient.intrinsics.incremental_search(ambient.Direction.forward)

def isearch_backward():
	return ambient.intrinsics.incremental_search(ambient.Direction.backward)

def matching_paren(ed = None):
	return ambient.intrinsics.matching_paren(ed, False)

def extend_to_matching_paren(ed = None):
	return ambient.intrinsics.matching_paren(ed, True)


from ambient.bindings import *
k = InputMappingScheme.get()
for c in range(0, 0xff):
	try:
		k.define(KeyStroke('%c' % c), ambient.intrinsics.input_typed_character)
		k.define(KeyStroke('%c' % c, ModifierKey.shift), ambient.intrinsics.input_typed_character)
	except:
		pass
k.define(KeyStroke(NaturalKey.delete), ambient.intrinsics.delete_forward_character)
k.define(KeyStroke(NaturalKey.back_space), ambient.intrinsics.delete_backward_character)
k.define(KeyStroke(NaturalKey.delete, ModifierKey.ctrl), ambient.intrinsics.delete_forward_word)
k.define(KeyStroke(NaturalKey.back_space, ModifierKey.ctrl), ambient.intrinsics.delete_backward_word)
# k.define(KeyStroke(NaturalKey.delete, ModifierKey.ctrl_shift), ambient.intrinsics.delete_line)
k.define(KeyStroke(NaturalKey.enter), ambient.intrinsics.newline)
k.define(KeyStroke(NaturalKey.enter, ModifierKey.shift), ambient.intrinsics.newline)
k.define(KeyStroke(NaturalKey.enter, ModifierKey.ctrl), ambient.intrinsics.insert_previous_line)
k.define(KeyStroke('Z', ModifierKey.ctrl), ambient.intrinsics.undo)
k.define(KeyStroke(NaturalKey.back_space, ModifierKey.alt), ambient.intrinsics.undo)
k.define(KeyStroke('Y', ModifierKey.ctrl), ambient.intrinsics.redo)
k.define(KeyStroke('Z', ModifierKey.ctrl_shift), ambient.intrinsics.redo)
k.define(KeyStroke(NaturalKey.back_space, ModifierKey.shift_alt), ambient.intrinsics.redo)
k.define(KeyStroke('X', ModifierKey.ctrl), cut_selection)
k.define(KeyStroke(NaturalKey.delete, ModifierKey.shift), cut_selection)
k.define(KeyStroke('C', ModifierKey.ctrl), copy_selection)
k.define(KeyStroke(NaturalKey.insert, ModifierKey.ctrl), copy_selection)
k.define(KeyStroke('V', ModifierKey.ctrl), paste)
k.define(KeyStroke(NaturalKey.insert, ModifierKey.shift), paste)
k.define(KeyStroke('V', ModifierKey.ctrl_shift), paste_from_killring)
k.define(KeyStroke(NaturalKey.insert, ModifierKey.ctrl_shift), paste_from_killring)
# k.define(KeyStroke('\t'), ambient.intrinsics.indent)
# k.define(KeyStroke('\t', ModifierKey.shift), ambient.intrinsics.unindent)
k.define(KeyStroke('X', ModifierKey.alt), ambient.intrinsics.convert_character_to_code_point)
k.define(KeyStroke('X', ModifierKey.shift_alt), ambient.intrinsics.convert_code_point_to_character)
k.define(KeyStroke(NaturalKey.convert), ambient.intrinsics.reconvert)
k.define(KeyStroke(NaturalKey.insert), ambient.intrinsics.toggle_overtype_mode)
k.define(KeyStroke(' ', ModifierKey.ctrl), ambient.intrinsics.show_completion_proposals_popup)
k.define(KeyStroke(NaturalKey.home, ModifierKey.ctrl), ambient.intrinsics.beginning_of_buffer)
k.define(KeyStroke(NaturalKey.end, ModifierKey.ctrl), ambient.intrinsics.end_of_buffer)
k.define(KeyStroke(NaturalKey.home), ambient.intrinsics.contextual_beginning_of_visual_line)
k.define(KeyStroke(NaturalKey.end), ambient.intrinsics.end_of_visual_line)
k.define(KeyStroke(NaturalKey.right), ambient.intrinsics.forward_character)
k.define(KeyStroke(NaturalKey.left), ambient.intrinsics.backward_character)
k.define(KeyStroke(NaturalKey.right, ModifierKey.ctrl), ambient.intrinsics.forward_word)
k.define(KeyStroke(NaturalKey.left, ModifierKey.ctrl), ambient.intrinsics.backward_word)
k.define(KeyStroke(NaturalKey.down), ambient.intrinsics.forward_visual_line)
k.define(KeyStroke(NaturalKey.up), ambient.intrinsics.backward_visual_line)
k.define(KeyStroke(NaturalKey.page_down), ambient.intrinsics.forward_page)
k.define(KeyStroke(NaturalKey.page_up), ambient.intrinsics.backward_page)
k.define(KeyStroke(NaturalKey.home, ModifierKey.ctrl_shift), extend_to_beginning_of_buffer)
k.define(KeyStroke(NaturalKey.end, ModifierKey.ctrl_shift), extend_to_end_of_buffer)
k.define(KeyStroke(NaturalKey.home, ModifierKey.shift), extend_to_contextual_beginning_of_visual_line)
k.define(KeyStroke(NaturalKey.end, ModifierKey.shift), extend_to_end_of_visual_line)
k.define(KeyStroke(NaturalKey.right, ModifierKey.shift), extend_to_forward_character)
k.define(KeyStroke(NaturalKey.left, ModifierKey.shift), extend_to_backward_character)
k.define(KeyStroke(NaturalKey.right, ModifierKey.ctrl_shift), extend_to_forward_word)
k.define(KeyStroke(NaturalKey.left, ModifierKey.ctrl_shift), extend_to_backward_word)
k.define(KeyStroke(NaturalKey.down, ModifierKey.shift), extend_to_forward_visual_line)
k.define(KeyStroke(NaturalKey.up, ModifierKey.shift), extend_to_backward_visual_line)
k.define(KeyStroke(NaturalKey.page_down, ModifierKey.shift), extend_to_forward_page)
k.define(KeyStroke(NaturalKey.page_up, ModifierKey.shift), extend_to_backward_page)
k.define(KeyStroke(NaturalKey.right, ModifierKey.shift_alt), select_rows_to_forward_character)
k.define(KeyStroke(NaturalKey.left, ModifierKey.shift_alt), select_rows_to_backward_character)
k.define(KeyStroke(NaturalKey.down, ModifierKey.shift_alt), select_rows_to_forward_visual_line)
k.define(KeyStroke(NaturalKey.up, ModifierKey.shift_alt), select_rows_to_backward_visual_line)
k.define(KeyStroke(NaturalKey.right, ModifierKey.ctrl_shift_alt), select_rows_to_forward_word)
k.define(KeyStroke(NaturalKey.left, ModifierKey.ctrl_shift_alt), select_rows_to_backward_word)
k.define(KeyStroke(NaturalKey.page_down, ModifierKey.shift_alt), select_rows_to_forward_page)
k.define(KeyStroke(NaturalKey.page_up, ModifierKey.shift_alt), select_rows_to_backward_page)
k.define(KeyStroke(NaturalKey.home, ModifierKey.ctrl_shift_alt), select_rows_to_beginning_of_buffer)
k.define(KeyStroke(NaturalKey.end, ModifierKey.ctrl_shift_alt), select_rows_to_end_of_buffer)
k.define(KeyStroke(NaturalKey.home, ModifierKey.shift_alt), select_rows_to_contextual_beginning_of_visual_line)
k.define(KeyStroke(NaturalKey.end, ModifierKey.shift_alt), select_rows_to_end_of_visual_line)
k.define(KeyStroke('A', ModifierKey.ctrl), ambient.intrinsics.select_all)
k.define(KeyStroke('W', ModifierKey.ctrl), ambient.intrinsics.select_word)
k.define(KeyStroke(NaturalKey.escape), ambient.intrinsics.cancel)
k.define(KeyStroke('T', ModifierKey.ctrl), ambient.intrinsics.transpose_characters)
k.define(KeyStroke('T', ModifierKey.ctrl_shift), ambient.intrinsics.transpose_words)
k.define((KeyStroke('N', ModifierKey.alt), KeyStroke('N')), narrow_to_selected_region)
k.define((KeyStroke('N', ModifierKey.alt), KeyStroke('W')), widen)
k.define(KeyStroke('F', ModifierKey.ctrl), ambient.ui.SearchDialog.show)
k.define(KeyStroke(NaturalKey.f3), search_forward_again)
k.define(KeyStroke(NaturalKey.f3, ModifierKey.shift), search_backward_again)
k.define(KeyStroke('I', ModifierKey.ctrl), isearch_forward)
k.define(KeyStroke('I', ModifierKey.ctrl_shift), isearch_backward)
k.define(KeyStroke('G', ModifierKey.ctrl), ambient.ui.goto_line_dialog)
k.define(KeyStroke(NaturalKey.f2, ModifierKey.ctrl), toggle_bookmark)
k.define(KeyStroke(NaturalKey.f2), ambient.intrinsics.forward_bookmark)
k.define(KeyStroke(NaturalKey.f2, ModifierKey.shift), ambient.intrinsics.backward_bookmark)
#k.define(KeyStroke(')', ModifierKey.ctrl), matching_paren)
k.define(KeyStroke(']', ModifierKey.ctrl), matching_paren)
#k.define(KeyStroke('}', ModifierKey.ctrl), matching_paren)
#k.define(KeyStroke(')', ModifierKey.ctrl_shift), extend_to_matching_paren)
k.define(KeyStroke(']', ModifierKey.ctrl_shift), extend_to_matching_paren)
#k.define(KeyStroke('}', ModifierKey.ctrl_shift), extend_to_matching_paren)
